# dylp.h File Reference

`#include "dylib_errs.h"`
`#include "dylib_io.h"`
`#include "dy_consys.h"`
Include dependency graph for dylp.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Classes
struct | basisel_struct
struct | basis_struct
struct | lpprob_struct
struct | lptols_struct
struct | lpopts_struct
struct | lpstats_struct
struct | lp_struct
## Defines
#define | ladPRIMFEAS 1<<0
#define | ladPRIMALCHK 1<<1
#define | ladPFQUIET 1<<2
#define | ladDUALFEAS 1<<3
#define | ladDUALCHK 1<<4
#define | ladDFQUIET 1<<5
#define | ladDUALS 1<<6
#define | ladPRIMALS 1<<7
#define | ladFACTOR 1<<8
#define | ladEXPAND 1<<9
#define | vstatINV 0
#define | vstatBFX 1<<0
#define | vstatBUB 1<<1
#define | vstatB 1<<2
#define | vstatBLB 1<<3
#define | vstatBFR 1<<4
#define | vstatNBFX 1<<5
#define | vstatNBUB 1<<6
#define | vstatNBLB 1<<7
#define | vstatNBFR 1<<8
#define | vstatSB 1<<9
#define | vstatBUUB 1<<10
#define | vstatBLLB 1<<11
#define | vstatNOPIVOT ((flags) 1<<(sizeof(flags)*8-2))
#define | vstatNOPER ((flags) 1<<(sizeof(flags)*8-3))
#define | vstatNOLOAD ((flags) 1<<(sizeof(flags)*8-4))
#define | vstatBASIC (vstatBFX|vstatBUUB|vstatBUB|vstatB|vstatBLB|vstatBLLB|vstatBFR)
#define | vstatNONBASIC (vstatNBFX|vstatNBUB|vstatNBLB)
#define | vstatEXOTIC (vstatSB|vstatNBFR)
#define | vstatSTATUS (vstatBASIC|vstatNONBASIC|vstatEXOTIC)
#define | vstatQUALS (vstatNOPIVOT|vstatNOPER|vstatNOLOAD)
#define | VALID_STATUS(zz_status_zz)
#define | lpctlNOFREE 1<<0
#define | lpctlONLYFREE 1<<1
#define | lpctlUBNDCHG 1<<2
#define | lpctlLBNDCHG 1<<3
#define | lpctlRHSCHG 1<<4
#define | lpctlOBJCHG 1<<5
#define | lpctlACTVARSIN 1<<6
#define | lpctlINITACTVAR 1<<7
#define | lpctlINITACTCON 1<<8
#define | lpctlACTVARSOUT 1<<10
#define | lpctlDYVALID 1<<11
#define | BND_TOLER dy_tols->pfeas
#define | INF_TOLER dy_tols->inf
#define | withintol(zz_val_zz, zz_tgt_zz, zz_tol_zz) (fabs((zz_val_zz)-(zz_tgt_zz)) <= zz_tol_zz)
#define | setcleanzero(zz_val_zz, zz_tol_zz) if (fabs(zz_val_zz) < zz_tol_zz) zz_val_zz = 0
#define | atbnd(zz_val_zz, zz_bnd_zz)
#define | belowbnd(zz_val_zz, zz_bnd_zz)
#define | abovebnd(zz_val_zz, zz_bnd_zz)
#define | withinbnds(zz_lb_zz, zz_val_zz, zz_ub_zz) (!abovebnd(zz_val_zz,zz_ub_zz) && !belowbnd(zz_val_zz,zz_lb_zz))
#define | snaptol1(zz_tgt_zz) (dy_tols->zero*(1.0+(zz_tgt_zz)))
#define | snaptol2(zz_tgt_zz, zz_dst_zz) (dy_tols->zero*(1.0+maxx((zz_tgt_zz),(zz_dst_zz))))
#define | snaptol3(zz_tol_zz, zz_tgt_zz, zz_dst_zz) ((zz_tol_zz)*(1.0+maxx((zz_tgt_zz),(zz_dst_zz))))
#define | DYSTATS_MAXDEGEN 25
#define | DYSTATS_HISTBINS 37
#define | ACTIVE_CON(zz_cndx_zz) (dy_origcons[(zz_cndx_zz)] > 0)
#define | INACTIVE_CON(zz_cndx_zz) (dy_origcons[(zz_cndx_zz)] <= 0)
#define | LOADABLE_CON(zz_cndx_zz) (dy_origcons[(zz_cndx_zz)] == 0)
#define | MARK_UNLOADABLE_CON(zz_cndx_zz) (dy_origcons[(zz_cndx_zz)] = -1)
#define | MARK_INACTIVE_CON(zz_cndx_zz) (dy_origcons[(zz_cndx_zz)] = 0)
#define | ACTIVE_VAR(zz_vndx_zz) (dy_origvars[(zz_vndx_zz)] > 0)
#define | INACTIVE_VAR(zz_vndx_zz) (dy_origvars[(zz_vndx_zz)] <= 0)
#define | LOADABLE_VAR(zz_vndx_zz)
#define | MARK_INACTIVE_VAR(zz_vndx_zz, zz_val_zz) (dy_origvars[(zz_vndx_zz)] = (zz_val_zz))
## Enumerations
enum | lpret_enum { lpFATAL = -1, lpINV = 0, lpOPTIMAL, lpUNBOUNDED, lpSWING, lpINFEAS, lpACCCHK, lpSTALLED, lpITERLIM, lpNOSPACE, lpLOSTFEAS, lpPUNT, lpFORCEDUAL, lpFORCEPRIMAL, lpFORCEFULL }
enum | dyphase_enum { dyINV = 0, dyINIT, dyPRIMAL1, dyPRIMAL2, dyDUAL, dyPURGEVAR, dyGENVAR, dyADDVAR, dyPURGECON, dyGENCON, dyADDCON, dyFORCEDUAL, dyFORCEPRIMAL, dyFORCEFULL, dyDONE }
enum | dyret_enum { dyrFATAL = -10, dyrITERLIM, dyrSTALLED, dyrBSPACE = -7, dyrSINGULAR = -6, dyrNUMERIC = -5, dyrLOSTPFEAS, dyrLOSTDFEAS, dyrDEGEN, dyrMADPIV, dyrINV = 0, dyrOK = 1, dyrPATCHED = 2, dyrRESELECT, dyrREQCHK, dyrACCCHK, dyrPUNT, dyrOPTIMAL, dyrUNBOUND, dyrSWING, dyrINFEAS }
enum | ibtype_enum { ibINV = 0, ibLOGICAL, ibSLACK, ibARCH }
enum | cxtype_enum { cxINV = 0, cxLOAD, cxUNLOAD, cxSINGLELP, cxINITIALLP, cxBANDC, cxUSERPIV }
## Functions
bool | dy_initlclsystem (lpprob_struct *orig_lp, bool hotstart)
void | dy_freelclsystem (lpprob_struct *orig_lp, bool freesys)
bool | dy_isscaled (void)
void | dy_scaling_vectors (const double **rscale, const double **cscale)
consys_struct * | dy_scaled_origsys ()
dyret_enum | dy_coldstart (consys_struct *orig_sys)
dyret_enum | dy_crash (void)
dyret_enum | dy_warmstart (lpprob_struct *orig_lp)
dyret_enum | dy_hotstart (lpprob_struct *orig_lp)
dyret_enum | dy_factor (flags *calcflgs)
dyret_enum | dy_pivot (int xipos, double abarij, double maxabarj)
double | dy_chkpiv (double abarij, double maxabarj)
void | dy_btran (double *col)
void | dy_ftran (double *col, bool save)
bool | dy_setpivparms (int curdelta, int mindelta)
char * | dy_prtpivparms (int lvl)
int | dy_activateBndCons (consys_struct *orig_sys)
int | dy_dualaddvars (consys_struct *orig_sys)
bool | dy_loadcon (consys_struct *orig_sys, int orig_ndx, bool genvars, int *inactndxs)
bool | dy_deactNBLogPrimCon (consys_struct *orig_sys, int i)
bool | dy_deactBLogPrimCon (consys_struct *orig_sys, int i)
bool | dy_actBLogPrimCon (consys_struct *orig_sys, int i, int *inactvars)
bool | dy_actBLogPrimConList (consys_struct *orig_sys, int cnt, int *ocndxs, int **inactvars)
int | dy_deactivateCons (consys_struct *orig_sys)
int | dy_activateCons (consys_struct *orig_sys, bool with_vars)
bool | dy_actNBPrimArch (consys_struct *orig_sys, int ovndx)
bool | dy_actNBPrimArchList (consys_struct *orig_sys, int cnt, int *ovndxs)
bool | dy_deactBPrimArch (consys_struct *orig_sys, int ovndx)
bool | dy_deactNBPrimArch (consys_struct *orig_sys, int ovndx)
int | dy_deactivateVars (consys_struct *orig_sys)
int | dy_activateVars (consys_struct *orig_sys, int *candidates)
dyret_enum | dy_primalin (int initcol, int scan, int *xjndx, int *nextcol)
dyret_enum | dy_primalpivot (int xjndx, int indir, int *xindx, int *outdir, double *abarij, double *delta, int *xjcand)
dyret_enum | dy_degenout (int level)
dyret_enum | dy_duenna (dyret_enum pivresult, int xjndx, int xindx, int xjcand, int xicand)
dyret_enum | dy_accchk (flags *checks)
dyret_enum | dy_addtopivrej (int xkndx, dyret_enum why, double abarij, double maxabarij)
dyret_enum | dy_dealWithPunt (void)
bool | dy_clrpivrej (int *entries)
void | dy_checkpivtol (void)
void | dy_initpivrej (int sze)
void | dy_freepivrej (void)
lpret_enum | dy_primal (void)
bool | dy_initp1obj (void)
bool | dy_swapobjs (dyphase_enum phase)
dyret_enum | dy_dualout (int *xindx)
dyret_enum | dy_dualpivot (int xindx, int outdir, int *p_xjndx, int *p_indir, double *p_cbarj, double *p_abarij, double *p_delta, int *xicand)
dyret_enum | dy_dualdegenout (int level)
lpret_enum | dy_dual (void)
void | dy_defaults (lpopts_struct **opts, lptols_struct **tols)
void | dy_checkdefaults (consys_struct *sys, lpopts_struct *opts, lptols_struct *tols)
void | dy_setprintopts (int lvl, lpopts_struct *opts)
lpret_enum | dylp (lpprob_struct *orig_lp, lpopts_struct *orig_opts, lptols_struct *orig_tols, lpstats_struct *orig_stats)
void * | dy_getOwner ()
lpret_enum | dyret2lpret (dyret_enum dyret)
dyret_enum | dy_updateprimals (int j, double deltaj, double *p_abarj)
bool | dy_reducerhs (double *rhs, bool init)
bool | dy_calcprimals (void)
bool | dy_calccbar (void)
void | dy_calcduals (void)
void | dy_setbasicstatus (void)
void | dy_dseinit (void)
void | dy_pseinit (void)
double | dy_calcobj (void)
double | dy_calcdualobj (void)
double | dy_calcpinfeas (void)
void | dy_finishup (lpprob_struct *orig_lp, dyphase_enum phase)
bool | dy_dupbasis (int dst_basissze, basis_struct **p_dst_basis, basis_struct *src_basis, int dst_statussze, flags **p_dst_status, int src_statuslen, flags *src_status)
void | dy_freesoln (lpprob_struct *lpprob)
bool | dy_pricenbvars (lpprob_struct *orig_lp, flags priceme, double **p_ocbar, int *p_nbcnt, int **p_nbvars)
bool | dy_pricedualpiv (lpprob_struct *orig_lp, int oxindx, double nubi, double xi, double nlbi, int nbcnt, int *nbvars, double *cbar, double *p_upeni, double *p_dpeni)
bool | dy_abarj (lpprob_struct *orig_lp, int tgt_j, double **p_abarj)
bool | dy_betaj (lpprob_struct *orig_lp, int tgt_j, double **p_betaj)
bool | dy_betak (lpprob_struct *orig_lp, int col_k, double **p_betaj)
bool | dy_betai (lpprob_struct *orig_lp, int tgt_i, double **p_betai)
bool | dy_abari (lpprob_struct *orig_lp, int tgt_i, double **p_abari, double **p_betai)
bool | dy_primalRays (lpprob_struct *orig_lp, int *p_numRays, double ***p_rays)
bool | dy_dualRays (lpprob_struct *orig_lp, bool fullRay, int *p_numRays, double ***p_rays, bool trueDuals)
void | dy_colDuals (lpprob_struct *orig_lp, double **p_cbar, bool trueDuals)
void | dy_rowDuals (lpprob_struct *orig_lp, double **p_y, bool trueDuals)
void | dy_rowDualsGivenC (lpprob_struct *orig_lp, double **p_y, const double *c, bool trueDuals)
void | dy_colPrimals (lpprob_struct *orig_lp, double **p_x)
void | dy_rowPrimals (lpprob_struct *orig_lp, double **p_xB, int **p_indB)
void | dy_logPrimals (lpprob_struct *orig_lp, double **p_logx)
void | dy_colStatus (lpprob_struct *orig_lp, flags **p_colstat)
void | dy_logStatus (lpprob_struct *orig_lp, flags **p_logstat)
bool | dy_expandxopt (lpprob_struct *lp, double **p_xopt)
void | dy_logpivot (dyret_enum result, int xjndx, int indir, double cbarj, int xindx, int outdir, double abarij, double delta)
const char * | dy_prtdyret (dyret_enum retcode)
const char * | dy_prtlpret (lpret_enum lpret)
const char ** | dy_prtlpphase (dyphase_enum phase, bool abbrv)
char * | dy_prtvstat (flags status)
bool | dy_dumpcompact (ioid chn, bool echo, lpprob_struct *soln, bool nbzeros)
void | dy_setlogchn (ioid chn)
void | dy_setgtxecho (bool echo)
void | dy_initstats (lpstats_struct **p_lpstats, consys_struct *orig_sys)
void | dy_dumpstats (ioid chn, bool echo, lpstats_struct *lpstats, consys_struct *orig_sys)
void | dy_freestats (lpstats_struct **p_lpstats)
void | dy_finalstats (lpstats_struct *lpstats)
## Variables
ioid | dy_logchn
bool | dy_gtxecho
void * | dy_owner
lp_struct * | dy_lp
consys_struct * | dy_sys
lptols_struct * | dy_tols
lpopts_struct * | dy_opts
int * | dy_actvars
int * | dy_actcons
int * | dy_origvars
int * | dy_origcons
int * | dy_basis
int * | dy_var2basis
int * | dy_brkout
int * | dy_degenset
int * | dy_ddegenset
flags * | dy_status
double * | dy_x
double * | dy_xbasic
double * | dy_y
double * | dy_cbar
double * | dy_gamma
double * | dy_rho
bool * | dy_frame
lpstats_struct * | dy_stats

## Define Documentation

#define ladPRIMFEAS 1<<0

Definition at line 317 of file dylp.h.

#define ladPRIMALCHK 1<<1

Definition at line 318 of file dylp.h.

#define ladPFQUIET 1<<2

Definition at line 319 of file dylp.h.

#define ladDUALFEAS 1<<3

Definition at line 320 of file dylp.h.

#define ladDUALCHK 1<<4

Definition at line 321 of file dylp.h.

#define ladDFQUIET 1<<5

Definition at line 322 of file dylp.h.

#define ladDUALS 1<<6

Definition at line 323 of file dylp.h.

#define ladPRIMALS 1<<7

Definition at line 324 of file dylp.h.

#define ladFACTOR 1<<8

Definition at line 325 of file dylp.h.

#define ladEXPAND 1<<9

Definition at line 326 of file dylp.h.

#define vstatINV 0

Definition at line 377 of file dylp.h.

#define vstatBFX 1<<0

Definition at line 378 of file dylp.h.

#define vstatBUB 1<<1

Definition at line 379 of file dylp.h.

#define vstatB 1<<2

Definition at line 380 of file dylp.h.

#define vstatBLB 1<<3

Definition at line 381 of file dylp.h.

#define vstatBFR 1<<4

Definition at line 382 of file dylp.h.

#define vstatNBFX 1<<5

Definition at line 383 of file dylp.h.

#define vstatNBUB 1<<6

Definition at line 384 of file dylp.h.

#define vstatNBLB 1<<7

Definition at line 385 of file dylp.h.

#define vstatNBFR 1<<8

Definition at line 386 of file dylp.h.

#define vstatSB 1<<9

Definition at line 387 of file dylp.h.

#define vstatBUUB 1<<10

Definition at line 388 of file dylp.h.

#define vstatBLLB 1<<11

Definition at line 389 of file dylp.h.

#define vstatNOPIVOT ((flags) 1<<(sizeof(flags)*8-2))

Definition at line 396 of file dylp.h.

#define vstatNOPER ((flags) 1<<(sizeof(flags)*8-3))

Definition at line 397 of file dylp.h.

#define vstatNOLOAD ((flags) 1<<(sizeof(flags)*8-4))

Definition at line 398 of file dylp.h.

#define vstatBASIC (vstatBFX|vstatBUUB|vstatBUB|vstatB|vstatBLB|vstatBLLB|vstatBFR)

Definition at line 400 of file dylp.h.

#define vstatNONBASIC (vstatNBFX|vstatNBUB|vstatNBLB)

Definition at line 402 of file dylp.h.

#define vstatEXOTIC (vstatSB|vstatNBFR)

Definition at line 403 of file dylp.h.

#define vstatSTATUS (vstatBASIC|vstatNONBASIC|vstatEXOTIC)

Definition at line 405 of file dylp.h.

#define vstatQUALS (vstatNOPIVOT|vstatNOPER|vstatNOLOAD)

Definition at line 406 of file dylp.h.

#define VALID_STATUS | ( | zz_status_zz |  | ) |

Value:

    (zz_status_zz == vstatBFX || zz_status_zz == vstatBUB || \
       zz_status_zz == vstatB   || zz_status_zz == vstatBLB || \
       zz_status_zz == vstatBFR || \
       zz_status_zz == vstatNBFX || zz_status_zz == vstatNBUB || \
       zz_status_zz == vstatNBLB || zz_status_zz == vstatNBFR || \
       zz_status_zz == vstatSB)

Definition at line 414 of file dylp.h.

#define lpctlNOFREE 1<<0

Definition at line 495 of file dylp.h.

#define lpctlONLYFREE 1<<1

Definition at line 496 of file dylp.h.

#define lpctlUBNDCHG 1<<2

Definition at line 497 of file dylp.h.

#define lpctlLBNDCHG 1<<3

Definition at line 498 of file dylp.h.

#define lpctlRHSCHG 1<<4

Definition at line 499 of file dylp.h.

#define lpctlOBJCHG 1<<5

Definition at line 500 of file dylp.h.

#define lpctlACTVARSIN 1<<6

Definition at line 501 of file dylp.h.

#define lpctlINITACTVAR 1<<7

Definition at line 502 of file dylp.h.

#define lpctlINITACTCON 1<<8

Definition at line 503 of file dylp.h.

#define lpctlACTVARSOUT 1<<10

Definition at line 505 of file dylp.h.

#define lpctlDYVALID 1<<11

Definition at line 507 of file dylp.h.

#define BND_TOLER dy_tols->pfeas

Definition at line 692 of file dylp.h.

#define INF_TOLER dy_tols->inf

Definition at line 696 of file dylp.h.

#define withintol | ( | zz_val_zz,
|  | zz_tgt_zz,
|  | zz_tol_zz |  | ) | (fabs((zz_val_zz)-(zz_tgt_zz)) <= zz_tol_zz)

Definition at line 699 of file dylp.h.

#define setcleanzero | ( | zz_val_zz,
|  | zz_tol_zz |  | ) | if (fabs(zz_val_zz) < zz_tol_zz) zz_val_zz = 0

Definition at line 702 of file dylp.h.

#define atbnd | ( | zz_val_zz,
|  | zz_bnd_zz |  | ) |

Value:

    ((fabs(zz_bnd_zz) < INF_TOLER) && \
       (fabs((zz_val_zz)-(zz_bnd_zz)) < BND_TOLER*(1.0+fabs(zz_bnd_zz))))

Definition at line 705 of file dylp.h.

#define belowbnd | ( | zz_val_zz,
|  | zz_bnd_zz |  | ) |

Value:

    ((fabs(zz_bnd_zz) < INF_TOLER) ? \
       (((zz_bnd_zz)-(zz_val_zz)) > BND_TOLER*(1.0+fabs(zz_bnd_zz))) : \
       (zz_val_zz < zz_bnd_zz))

Definition at line 709 of file dylp.h.

#define abovebnd | ( | zz_val_zz,
|  | zz_bnd_zz |  | ) |

Value:

    ((fabs(zz_bnd_zz) < INF_TOLER) ? \
       (((zz_val_zz)-(zz_bnd_zz)) > BND_TOLER*(1.0+fabs(zz_bnd_zz))) : \
       (zz_val_zz > zz_bnd_zz))

Definition at line 714 of file dylp.h.

#define withinbnds | ( | zz_lb_zz,
|  | zz_val_zz,
|  | zz_ub_zz |  | ) | (!abovebnd(zz_val_zz,zz_ub_zz) && !belowbnd(zz_val_zz,zz_lb_zz))

Definition at line 719 of file dylp.h.

#define snaptol1 | ( | zz_tgt_zz |  | ) | (dy_tols->zero*(1.0+(zz_tgt_zz)))

Definition at line 741 of file dylp.h.

#define snaptol2 | ( | zz_tgt_zz,
|  | zz_dst_zz |  | ) | (dy_tols->zero*(1.0+maxx((zz_tgt_zz),(zz_dst_zz))))

Definition at line 743 of file dylp.h.

#define snaptol3 | ( | zz_tol_zz,
|  | zz_tgt_zz,
|  | zz_dst_zz |  | ) | ((zz_tol_zz)*(1.0+maxx((zz_tgt_zz),(zz_dst_zz))))

Definition at line 746 of file dylp.h.

#define DYSTATS_MAXDEGEN 25

Definition at line 1300 of file dylp.h.

#define DYSTATS_HISTBINS 37

Definition at line 1301 of file dylp.h.

#define ACTIVE_CON | ( | zz_cndx_zz |  | ) | (dy_origcons[(zz_cndx_zz)] > 0)

Definition at line 1381 of file dylp.h.

#define INACTIVE_CON | ( | zz_cndx_zz |  | ) | (dy_origcons[(zz_cndx_zz)] <= 0)

Definition at line 1382 of file dylp.h.

#define LOADABLE_CON | ( | zz_cndx_zz |  | ) | (dy_origcons[(zz_cndx_zz)] == 0)

Definition at line 1383 of file dylp.h.

#define MARK_UNLOADABLE_CON | ( | zz_cndx_zz |  | ) | (dy_origcons[(zz_cndx_zz)] = -1)

Definition at line 1384 of file dylp.h.

#define MARK_INACTIVE_CON | ( | zz_cndx_zz |  | ) | (dy_origcons[(zz_cndx_zz)] = 0)

Definition at line 1385 of file dylp.h.

#define ACTIVE_VAR | ( | zz_vndx_zz |  | ) | (dy_origvars[(zz_vndx_zz)] > 0)

Definition at line 1387 of file dylp.h.

#define INACTIVE_VAR | ( | zz_vndx_zz |  | ) | (dy_origvars[(zz_vndx_zz)] <= 0)

Definition at line 1388 of file dylp.h.

#define LOADABLE_VAR | ( | zz_vndx_zz |  | ) |

Value:

    ((dy_origvars[(zz_vndx_zz)] < 0) && \
       flgoff(((flags) -dy_origvars[(zz_vndx_zz)]),vstatNOLOAD|vstatNBFX))

Definition at line 1389 of file dylp.h.

#define MARK_INACTIVE_VAR | ( | zz_vndx_zz,
|  | zz_val_zz |  | ) | (dy_origvars[(zz_vndx_zz)] = (zz_val_zz))

Definition at line 1392 of file dylp.h.

## Enumeration Type Documentation

enum lpret_enum

Enumerator:

  lpFATAL |
  lpINV |
  lpOPTIMAL |
  lpUNBOUNDED |
  lpSWING |
  lpINFEAS |
  lpACCCHK |
  lpSTALLED |
  lpITERLIM |
  lpNOSPACE |
  lpLOSTFEAS |
  lpPUNT |
  lpFORCEDUAL |
  lpFORCEPRIMAL |
  lpFORCEFULL |

Definition at line 170 of file dylp.h.

enum dyphase_enum

Enumerator:

  dyINV |
  dyINIT |
  dyPRIMAL1 |
  dyPRIMAL2 |
  dyDUAL |
  dyPURGEVAR |
  dyGENVAR |
  dyADDVAR |
  dyPURGECON |
  dyGENCON |
  dyADDCON |
  dyFORCEDUAL |
  dyFORCEPRIMAL |
  dyFORCEFULL |
  dyDONE |

Definition at line 212 of file dylp.h.

enum dyret_enum

Enumerator:

  dyrFATAL |
  dyrITERLIM |
  dyrSTALLED |
  dyrBSPACE |
  dyrSINGULAR |
  dyrNUMERIC |
  dyrLOSTPFEAS |
  dyrLOSTDFEAS |
  dyrDEGEN |
  dyrMADPIV |
  dyrINV |
  dyrOK |
  dyrPATCHED |
  dyrRESELECT |
  dyrREQCHK |
  dyrACCCHK |
  dyrPUNT |
  dyrOPTIMAL |
  dyrUNBOUND |
  dyrSWING |
  dyrINFEAS |

Definition at line 274 of file dylp.h.

enum ibtype_enum

Enumerator:

  ibINV |
  ibLOGICAL |
  ibSLACK |
  ibARCH |

Definition at line 766 of file dylp.h.

enum cxtype_enum

Enumerator:

  cxINV |
  cxLOAD |
  cxUNLOAD |
  cxSINGLELP |
  cxINITIALLP |
  cxBANDC |
  cxUSERPIV |

Definition at line 788 of file dylp.h.

## Function Documentation

bool dy_initlclsystem | ( | lpprob_struct * | orig_lp,
|  | bool | hotstart |
| ) |  |  |

void dy_freelclsystem | ( | lpprob_struct * | orig_lp,
|  | bool | freesys |
| ) |  |  |

bool dy_isscaled | ( | void |  | ) |

void dy_scaling_vectors | ( | const double ** | rscale,
|  | const double ** | cscale |
| ) |  |  |

consys_struct* dy_scaled_origsys | ( |  | ) |

dyret_enum dy_coldstart | ( | consys_struct * | orig_sys | ) |

dyret_enum dy_crash | ( | void |  | ) |

dyret_enum dy_warmstart | ( | lpprob_struct * | orig_lp | ) |

dyret_enum dy_hotstart | ( | lpprob_struct * | orig_lp | ) |

dyret_enum dy_factor | ( | flags * | calcflgs | ) |

dyret_enum dy_pivot | ( | int | xipos,
|  | double | abarij,
|  | double | maxabarj |
| ) |  |  |

double dy_chkpiv | ( | double | abarij,
|  | double | maxabarj |
| ) |  |  |

void dy_btran | ( | double * | col | ) |

void dy_ftran | ( | double * | col,
|  | bool | save |
| ) |  |  |

bool dy_setpivparms | ( | int | curdelta,
|  | int | mindelta |
| ) |  |  |

char* dy_prtpivparms | ( | int | lvl | ) |

int dy_activateBndCons | ( | consys_struct * | orig_sys | ) |

int dy_dualaddvars | ( | consys_struct * | orig_sys | ) |

bool dy_loadcon | ( | consys_struct * | orig_sys,
|  | int | orig_ndx,
|  | bool | genvars,
|  | int * | inactndxs |
| ) |  |  |

bool dy_deactNBLogPrimCon | ( | consys_struct * | orig_sys,
|  | int | i |
| ) |  |  |

bool dy_deactBLogPrimCon | ( | consys_struct * | orig_sys,
|  | int | i |
| ) |  |  |

bool dy_actBLogPrimCon | ( | consys_struct * | orig_sys,
|  | int | i,
|  | int * | inactvars |
| ) |  |  |

bool dy_actBLogPrimConList | ( | consys_struct * | orig_sys,
|  | int | cnt,
|  | int * | ocndxs,
|  | int ** | inactvars |
| ) |  |  |

int dy_deactivateCons | ( | consys_struct * | orig_sys | ) |

int dy_activateCons | ( | consys_struct * | orig_sys,
|  | bool | with_vars |
| ) |  |  |

bool dy_actNBPrimArch | ( | consys_struct * | orig_sys,
|  | int | ovndx |
| ) |  |  |

bool dy_actNBPrimArchList | ( | consys_struct * | orig_sys,
|  | int | cnt,
|  | int * | ovndxs |
| ) |  |  |

bool dy_deactBPrimArch | ( | consys_struct * | orig_sys,
|  | int | ovndx |
| ) |  |  |

bool dy_deactNBPrimArch | ( | consys_struct * | orig_sys,
|  | int | ovndx |
| ) |  |  |

int dy_deactivateVars | ( | consys_struct * | orig_sys | ) |

int dy_activateVars | ( | consys_struct * | orig_sys,
|  | int * | candidates |
| ) |  |  |

dyret_enum dy_primalin | ( | int | initcol,
|  | int | scan,
|  | int * | xjndx,
|  | int * | nextcol |
| ) |  |  |

dyret_enum dy_primalpivot | ( | int | xjndx,
|  | int | indir,
|  | int * | xindx,
|  | int * | outdir,
|  | double * | abarij,
|  | double * | delta,
|  | int * | xjcand |
| ) |  |  |

dyret_enum dy_degenout | ( | int | level | ) |

dyret_enum dy_duenna | ( | dyret_enum | pivresult,
|  | int | xjndx,
|  | int | xindx,
|  | int | xjcand,
|  | int | xicand |
| ) |  |  |

dyret_enum dy_accchk | ( | flags * | checks | ) |

dyret_enum dy_addtopivrej | ( | int | xkndx,
|  | dyret_enum | why,
|  | double | abarij,
|  | double | maxabarij |
| ) |  |  |

dyret_enum dy_dealWithPunt | ( | void |  | ) |

bool dy_clrpivrej | ( | int * | entries | ) |

void dy_checkpivtol | ( | void |  | ) |

void dy_initpivrej | ( | int | sze | ) |

void dy_freepivrej | ( | void |  | ) |

lpret_enum dy_primal | ( | void |  | ) |

bool dy_initp1obj | ( | void |  | ) |

bool dy_swapobjs | ( | dyphase_enum | phase | ) |

dyret_enum dy_dualout | ( | int * | xindx | ) |

dyret_enum dy_dualpivot | ( | int | xindx,
|  | int | outdir,
|  | int * | p_xjndx,
|  | int * | p_indir,
|  | double * | p_cbarj,
|  | double * | p_abarij,
|  | double * | p_delta,
|  | int * | xicand |
| ) |  |  |

dyret_enum dy_dualdegenout | ( | int | level | ) |

lpret_enum dy_dual | ( | void |  | ) |

void dy_defaults | ( | lpopts_struct ** | opts,
|  | lptols_struct ** | tols |
| ) |  |  |

void dy_checkdefaults | ( | consys_struct * | sys,
|  | lpopts_struct * | opts,
|  | lptols_struct * | tols |
| ) |  |  |

void dy_setprintopts | ( | int | lvl,
|  | lpopts_struct * | opts |
| ) |  |  |

lpret_enum dylp | ( | lpprob_struct * | orig_lp,
|  | lpopts_struct * | orig_opts,
|  | lptols_struct * | orig_tols,
|  | lpstats_struct * | orig_stats |
| ) |  |  |

void* dy_getOwner | ( |  | ) |

lpret_enum dyret2lpret | ( | dyret_enum | dyret | ) |

dyret_enum dy_updateprimals | ( | int | j,
|  | double | deltaj,
|  | double * | p_abarj |
| ) |  |  |

bool dy_reducerhs | ( | double * | rhs,
|  | bool | init |
| ) |  |  |

bool dy_calcprimals | ( | void |  | ) |

bool dy_calccbar | ( | void |  | ) |

void dy_calcduals | ( | void |  | ) |

void dy_setbasicstatus | ( | void |  | ) |

void dy_dseinit | ( | void |  | ) |

void dy_pseinit | ( | void |  | ) |

double dy_calcobj | ( | void |  | ) |

double dy_calcdualobj | ( | void |  | ) |

double dy_calcpinfeas | ( | void |  | ) |

void dy_finishup | ( | lpprob_struct * | orig_lp,
|  | dyphase_enum | phase |
| ) |  |  |

bool dy_dupbasis | ( | int | dst_basissze,
|  | basis_struct ** | p_dst_basis,
|  | basis_struct * | src_basis,
|  | int | dst_statussze,
|  | flags ** | p_dst_status,
|  | int | src_statuslen,
|  | flags * | src_status |
| ) |  |  |

void dy_freesoln | ( | lpprob_struct * | lpprob | ) |

bool dy_pricenbvars | ( | lpprob_struct * | orig_lp,
|  | flags | priceme,
|  | double ** | p_ocbar,
|  | int * | p_nbcnt,
|  | int ** | p_nbvars |
| ) |  |  |

bool dy_pricedualpiv | ( | lpprob_struct * | orig_lp,
|  | int | oxindx,
|  | double | nubi,
|  | double | xi,
|  | double | nlbi,
|  | int | nbcnt,
|  | int * | nbvars,
|  | double * | cbar,
|  | double * | p_upeni,
|  | double * | p_dpeni |
| ) |  |  |

bool dy_abarj | ( | lpprob_struct * | orig_lp,
|  | int | tgt_j,
|  | double ** | p_abarj |
| ) |  |  |

bool dy_betaj | ( | lpprob_struct * | orig_lp,
|  | int | tgt_j,
|  | double ** | p_betaj |
| ) |  |  |

bool dy_betak | ( | lpprob_struct * | orig_lp,
|  | int | col_k,
|  | double ** | p_betaj |
| ) |  |  |

bool dy_betai | ( | lpprob_struct * | orig_lp,
|  | int | tgt_i,
|  | double ** | p_betai |
| ) |  |  |

bool dy_abari | ( | lpprob_struct * | orig_lp,
|  | int | tgt_i,
|  | double ** | p_abari,
|  | double ** | p_betai |
| ) |  |  |

bool dy_primalRays | ( | lpprob_struct * | orig_lp,
|  | int * | p_numRays,
|  | double *** | p_rays |
| ) |  |  |

bool dy_dualRays | ( | lpprob_struct * | orig_lp,
|  | bool | fullRay,
|  | int * | p_numRays,
|  | double *** | p_rays,
|  | bool | trueDuals |
| ) |  |  |

void dy_colDuals | ( | lpprob_struct * | orig_lp,
|  | double ** | p_cbar,
|  | bool | trueDuals |
| ) |  |  |

void dy_rowDuals | ( | lpprob_struct * | orig_lp,
|  | double ** | p_y,
|  | bool | trueDuals |
| ) |  |  |

void dy_rowDualsGivenC | ( | lpprob_struct * | orig_lp,
|  | double ** | p_y,
|  | const double * | c,
|  | bool | trueDuals |
| ) |  |  |

void dy_colPrimals | ( | lpprob_struct * | orig_lp,
|  | double ** | p_x |
| ) |  |  |

void dy_rowPrimals | ( | lpprob_struct * | orig_lp,
|  | double ** | p_xB,
|  | int ** | p_indB |
| ) |  |  |

void dy_logPrimals | ( | lpprob_struct * | orig_lp,
|  | double ** | p_logx |
| ) |  |  |

void dy_colStatus | ( | lpprob_struct * | orig_lp,
|  | flags ** | p_colstat |
| ) |  |  |

void dy_logStatus | ( | lpprob_struct * | orig_lp,
|  | flags ** | p_logstat |
| ) |  |  |

bool dy_expandxopt | ( | lpprob_struct * | lp,
|  | double ** | p_xopt |
| ) |  |  |

void dy_logpivot | ( | dyret_enum | result,
|  | int | xjndx,
|  | int | indir,
|  | double | cbarj,
|  | int | xindx,
|  | int | outdir,
|  | double | abarij,
|  | double | delta |
| ) |  |  |

const char* dy_prtdyret | ( | dyret_enum | retcode | ) |

const char* dy_prtlpret | ( | lpret_enum | lpret | ) |

const char* * dy_prtlpphase | ( | dyphase_enum | phase,
|  | bool | abbrv |
| ) |  |  |

char* dy_prtvstat | ( | flags | status | ) |

bool dy_dumpcompact | ( | ioid | chn,
|  | bool | echo,
|  | lpprob_struct * | soln,
|  | bool | nbzeros |
| ) |  |  |

void dy_setlogchn | ( | ioid | chn | ) |

void dy_setgtxecho | ( | bool | echo | ) |

void dy_initstats | ( | lpstats_struct ** | p_lpstats,
|  | consys_struct * | orig_sys |
| ) |  |  |

void dy_dumpstats | ( | ioid | chn,
|  | bool | echo,
|  | lpstats_struct * | lpstats,
|  | consys_struct * | orig_sys |
| ) |  |  |

void dy_freestats | ( | lpstats_struct ** | p_lpstats | ) |

void dy_finalstats | ( | lpstats_struct * | lpstats | ) |

## Variable Documentation

ioid dy_logchn

bool dy_gtxecho

void* dy_owner

lp_struct* dy_lp

consys_struct* dy_sys

lptols_struct* dy_tols

lpopts_struct* dy_opts

int* dy_actvars

int * dy_actcons

int * dy_origvars

int * dy_origcons

int * dy_basis

int * dy_var2basis

int * dy_brkout

int * dy_degenset

int * dy_ddegenset

flags* dy_status

double* dy_x

double * dy_xbasic

double * dy_y

double * dy_cbar

double * dy_gamma

double * dy_rho

bool* dy_frame

lpstats_struct* dy_stats

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines